*
      SUBROUTINE CAL_SYEV1N(NAME, UPLO, N, NPROW,NPCOL, AMEM, MEMSIZE,
     $                   NB, VL, VU, IL, IU, ABSTOL, INFILEA, OUTFILE,
     $                   TFILE,  NPRT, CTXT)
*
*      (PDSYEV1, PDSYEV3, PDSYEV5)
*        QL  QR - 
*
      include 'mpif.h'
*
*  
      INTEGER            N, NPROW, NPCOL, NB, MEMSIZE, IL, IU,
     $                   NPRT, CTXT
      DOUBLE PRECISION   AMEM( MEMSIZE ), VL, VU, ABSTOL
      CHARACTER*(*)      INFILEA, OUTFILE, NAME, UPLO, TFILE
*
*   -  
      INTEGER            NOUT, NIN, NPR
      PARAMETER          ( NOUT1 = 12, NOUT = 13, NIN = 11, NPR = 6 )
*
*  
      INTEGER            ANB, I, IAM, INFO, IPA, IPEV,
     $                   IPGAP, IPFAIL, IPCLUSTR, IPW, IPWOR, IPIWOR,
     $                   NP, NQ, M, MYCOL, MYROW, MXNP, MXNQ,
     S                   NEIG, NN, NZ, LWOPT, LWORK, LIWORK, IA, JA,
     $                   NPROCS, NPS, NSYTRD, MMIN, SQNPC, WORKSIZ
*
*  
      INTEGER            DESCA( 9 )
      DOUBLE PRECISION   ALWORK(1), time, time1, time2
*
      COMMON             time, J
*
*  
      INTEGER            ICEIL, ILCM, NUMROC, MAX
      DOUBLE PRECISION   PDLAMCH, PDLANGE
      EXTERNAL           ICEIL, ILCM, NUMROC, PDLAMCH, PDLANGE
*
*  
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PDLAPRNT, PDLAREAD,
     $                   PDLAWRITE, MINTSYEV1,
     $                   PDSYEV1, PDSYEV3, PDSYEV5
*
*  
      INTRINSIC          ABS, DBLE, MAX, MIN, MOD, SQRT, INT
*
*  
*
*  
*
      IA = 1
      JA = 1
*
*    BLACS'    
***
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
*       ,
*    
*
      IF( MYROW.GE.NPROW .OR. MYCOL.GE.NPCOL ) GO TO 20
*
       NP = NUMROC( N, NB, MYROW, 0, NPROW )
       NQ = NUMROC( N, NB, MYCOL, 0, NPCOL )
*
*      A
*
      CALL DESCINIT(DESCA, N, N, NB, NB, 0, 0, CTXT, MAX(1,NP), INFO)
*
*     AMEM
*
*     A
      IPA = 1
*
*     EV ( )
      IPEV = IPA + DESCA(9)*NQ
*     WORK
      IPWOR = IPEV + N
*     W
*
      LWORK = 5*N + MAX( NB*( NP + 1 ), 3*NB ) + 1
      IPW = IPWOR + LWORK
*
      IF( NAME .NE. 'PDSYEV3' .AND. NAME .NE. 'PDSYEV5' ) GOTO 5
*
*   ,    PDSYEV3(5)
*
      NP0 = NUMROC( N, NB, 0, 0, NPROW )
*
      NN = MAX( N, NB, 2 )
      LWMIN = 5*N + MAX( 5*NN, NB*( NP0+1 ) )
      LWORK = LWMIN
*
      LIWORK = 6*MAX( N, NPROCS+1, 4 )
*
*     IWORK
      IPIWOR = IPWOR + LWORK
      IPW = IPIWOR + LIWORK
*
      GOTO 3
*
    5 IF( NAME .NE. 'PDSYEV1' ) GOTO 10
*
      GOTO 3
*
*     PDLAPRNT  .
*
    3 WORKSIZ = MAX( NB, NP )
*
*        
*
      INFO = 0
      MMIN = IPW + WORKSIZ
*
*      ( MMIN )
*
      IF(IPW + WORKSIZ .GT. MEMSIZE ) THEN
         IF( IAM .EQ. 0 ) WRITE( NPR, FMT = * )'  '
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 ) WRITE( NOUT, FMT = * )'  '
         INFO = 1
      END IF
*
*   INFO    
*
      CALL IGSUM2D( CTXT, 'All', ' ', 1, 1, INFO, 1, -1, 0 )
      IF( INFO .GT. 0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 )
     $       WRITE( NOUT, FMT = * ) '   '
         GO TO 10
      END IF
*
*   ( )     A
*
      IF( INFILEA .EQ. ' ' ) THEN
         CALL MINTSYEV1( N, AMEM(IPA), DESCA, INFO )
      ELSE
         CALL PDLAREAD(INFILEA, AMEM(IPA), DESCA, 0, 0, AMEM(IPW))
      END IF
*
*    
      IF( NPRT .EQ. 0 .OR. NPRT .EQ. 1 .OR. NPRT .EQ. 2 ) GO TO 8
      IF( J .NE. 1 ) GO TO 8
*
*      
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = 9992 )NAME
         WRITE( NPR, FMT = 9998 )N, N, NB, NB
         WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NPR, FMT = * ) '     '
         WRITE( NPR, FMT = * )'   IPA,   IPEV,  IPWOR,   IPW,  MMIN'
         WRITE( NPR, FMT = 9994 )IPA, IPEV, IPWOR, IPW, MMIN
*
         WRITE( NPR, FMT = * ) '  DESCA'
         WRITE( NPR, FMT = 9985 )DESCA
         WRITE( NPR, FMT = * ) '  A'
      END IF
*
 9994 FORMAT( / 5I7 /)
 9985 FORMAT( / 9I5 /)
*
      CALL PDLAPRNT( N, N, AMEM(IPA), IA, JA, DESCA, 0, 0, 'A',
     $               NPR, AMEM( IPW ) )
*
*     
*
    8 IF( NAME .EQ. 'PDSYEV3' ) GOTO 11
      IF( NAME .EQ. 'PDSYEV5' ) GOTO 12
      IF( NAME .NE. 'PDSYEV1' ) GOTO 10
*
      time1 = MPI_Wtime()
*
      CALL PDSYEV1( UPLO, N, AMEM(IPA), IA, JA, DESCA,
     $              AMEM(IPEV), AMEM(IPWOR), LWORK, INFO )
*
      time2 = MPI_Wtime()
      time = time2 - time1
*
 9999 FORMAT( /' (Wtime) =', D14.3, ' time1 =', D12.3,
     $        ' time2 =', D14.3 )
*
      GOTO 99
*
   11 time1 = MPI_Wtime()
*
      CALL PDSYEV3( UPLO, N, AMEM(IPA), IA, JA, DESCA, VL, VU, ABSTOL,
     $              M, AMEM(IPEV), AMEM(IPWOR), LWORK,
     $              AMEM(IPIWOR), LIWORK, INFO)
*
      time2 = MPI_Wtime()
      time = time2 - time1
*
      GOTO 99
*
   12 time1 = MPI_Wtime()
*
      CALL PDSYEV5( UPLO, N, AMEM(IPA), IA, JA, DESCA, IL, IU, ABSTOL,
     $              M, AMEM(IPEV), AMEM(IPWOR), LWORK,
     $              AMEM(IPIWOR), LIWORK, INFO)
*
      time2 = MPI_Wtime()
      time = time2 - time1
*
      GOTO 99
*
*  
*
   99 CONTINUE
*
*    
*
      IF( J .NE. 1 .AND. J .NE. 2000 ) GO TO 25
      IF( NPRT .EQ. 0 .OR. NPRT .EQ. 1 ) GO TO 28
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  '
         WRITE( NPR, FMT = 9995 )INFO, UPLO
      IF( NAME .NE. 'PDSYEV3' ) GOTO 15
         WRITE( NPR, FMT = 9991 ) VL, VU
   15 IF( NAME .NE. 'PDSYEV5' ) GOTO 16
         WRITE( NPR, FMT = 9989 ) IL, IU
   16 IF( NAME .EQ. 'PDSYEV1' ) GOTO 14
      WRITE( NPR, FMT = 9993 ) ABSTOL
      WRITE( NPR, FMT = 9990 ) M
*
   14   WRITE( NPR, FMT = * ) '  '
      IF( NAME .NE. 'PDSYEV1' ) GOTO 17
        NEX = N
        GOTO 23
   17   NEX = M
   23    DO 18 I = IPEV, IPEV+NEX-1
         PRINT *, ' W(', I-IPEV+1, ')=', AMEM( I ), ';'
   18   CONTINUE
      END IF
*
 9989 FORMAT( / ' IL = ', I5, ' IU = ', I5 / )
 9991 FORMAT( / ' VL = ', D20.12, ' VU = ', D20.12 / )
 9993 FORMAT( / ' ABSTOL = ', D20.12 /)
 9990 FORMAT( / ' M = ', I5 /)
*
***
   28 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
        WRITE( NPR, FMT = * )' : ', MMIN, MEMSIZE, J
      END IF
   25 CONTINUE
*
*        
*  ,      ' '.
***
*
      IF( OUTFILE .EQ. ' ' ) GO TO 30
***

*     
*
   19 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         WRITE(NOUT, FMT = *)'   '
         WRITE(NOUT, FMT = *)' '
*
      IF( NAME .NE. 'PDSYEV3' .AND. NAME .NE. 'PDSYEV5' ) GOTO 22
         WRITE(NOUT, FMT = *) M, 1
         DO 21 I = 1, M
            WRITE( NOUT, FMT = * ) AMEM( IPEV+I-1 )
   21    CONTINUE
      GO TO 10
*
   22    WRITE(NOUT, FMT = *) N, 1
         DO 27 I = 1, N
            WRITE( NOUT, FMT = * ) AMEM( IPEV+I-1 )
   27    CONTINUE
*
      END IF
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         IF( NOUT .NE. 6 .AND. NOUT .NE. 0 ) CLOSE( NOUT )
      END IF
*
***
   30 CONTINUE
*
*         WRITE( NPR, FMT = * ) '  '
*
*       
*   ,  
***
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
*
        IF( J .NE. 1 ) GO TO 31
*
          WRITE( NOUT1, FMT = * )' : ', MMIN, MEMSIZE, J
*
   31   WRITE( NOUT1, FMT = 2001 ) NPROW, NPCOL, NB, time
*
      END IF
*
   10 CONTINUE
*
   20 CONTINUE
*
      IF( IAM .EQ. 0 ) THEN
         IF( NOUT .NE. 6 .AND. NOUT .NE. 0 ) CLOSE( NOUT )
      END IF
*
 2001 FORMAT( 3I5, D14.3/ )
*
 9992 FORMAT( / '    ', A7 )
 9998 FORMAT(/'     ,',//,
     $       '  A -  ',I5,'  ',I5,',',
     $       /'         ', I2, '  ', I2, /)
 9997 FORMAT( / '   ', I3, ' ,',
     $       '    ', I2, '  ', I2 /)
 9995 FORMAT( / '  INFO =', I6, '    UPLO  = ', A1 /)
* 9996 FORMAT( / '  INFO  = ', I6 /)
      RETURN
      END
